#include <iostream.h>
#include <stdlib.h>
#include <math.h>

const double pi=3.14159265358979323846;
const int N=1000;  //  
const int n=N-1;
const double a=0,b=pi; // [a,b]


int main() {
 double f[N+1], tau,x,alpha[n],beta[n],c[n],tmp=0;
 int i;

      tau=(b-a)/N;
      for(i=0;i<=N;i++)  {
         x=a+tau*i;
         f[i]=sin(x); // f(x)
      }
      alpha[0]=-1/4;
      beta[0]=f[2]-2*f[1]+f[0];
      // ,  
      for (i=1;i<n;i++) {
         alpha[i]=-1/(alpha[i-1]+4);
         beta[i]=(f[i+2]-2*f[i+1]+f[i]-beta[i-1])/(alpha[i-1]+4);
      }

      c[n-1]=(f[N]-2*f[N-1]+f[N-2]-beta[n-1])/(4+alpha[n-1]);
      // 
      for (i=n-2;i>=0;i--) {
         c[i]=alpha[i+1]*c[i+1]+beta[i+1];
      }

      for(i=0;i<n;i++) c[i]=c[i]*3/(tau*tau);

      //      (9):
      x=(5*f[0]+13*f[1]+13*f[N-1]+5*f[N])/12;
      for(i=2;i<N-1;i++) tmp=tmp+f[i];
      x=(x+tmp)*tau-(c[0]+c[n-1])*tau*tau*tau/36;

      cout<<"J1="<<x<<endl;

      //      (6):
      tmp=0;
      x=(f[0]+f[N])/2;
      for(i=1;i<N;i++) tmp=tmp+f[i];
      x=(x+tmp)*tau;
      tmp=0;
      for(i=0;i<n;i++) tmp=tmp+c[i];
      tmp=tmp*tau*tau*tau/6;
       cout<<"J2="<<x<<endl;
           cin>>x;
      return 0;
}
